using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using Benday.MvvmTips.ViewModels;
using Microsoft.Silverlight.Testing;

namespace Benday.MvvmTips.UnitTests
{

    [TestClass]
    public class MessageBoxSampleViewModelFixture : SilverlightUnitTestBase
    {
        public MessageBoxSampleViewModelFixture()
        {
        }

        [TestMethod]
        [Tag("MessageBox")]
        public void MethodThatAsksForAMessageBoxActuallyRequestsAMessageBox()
        {
            var instance = new MessageBoxSampleViewModel();

            var tester = new MessageBoxViewModelTester(instance);

            instance.DoSomethingThatNeedsAMessageBox();

            tester.AssertMessage("Hi.  I'd like a message box.");
        }

        [TestMethod]
        [Tag("MessageBox")]
        public void MethodThatThrowsAnExceptionRequestsForAMessageBox()
        {
            var instance = new MessageBoxSampleViewModel();

            var tester = new MessageBoxViewModelTester(instance);

            instance.DoSomethingThatThrowsAnException();

            tester.AssertException<DivideByZeroException>();
            tester.AssertMessage("Something went horribly wrong.");
        }
    }
}
