using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.MvvmTips.ViewModels;
using Benday.MvvmTips.Models;

namespace Benday.MvvmTips.UnitTests
{
    [TestClass]
    public class PersonModelToViewModelAdapterFixture : SilverlightUnitTestBase
    {
        protected override void OnTestInitialize()
        {
            m_AdapterInstance = null;
            m_ViewModelInstance = null;
            m_ModelInstance = null;
        }

        [TestMethod]
        public void AdaptModelToViewModel()
        {
            UnitTestUtility.PopulateWithTestData(ModelInstance);

            AdapterInstance.Adapt(ModelInstance, ViewModelInstance);

            UnitTestUtility.AssertAreEqual(ModelInstance, ViewModelInstance);
        }

        [TestMethod]
        public void AdaptViewModelToModel()
        {
            UnitTestUtility.PopulateWithTestData(ViewModelInstance);

            AdapterInstance.Adapt(ViewModelInstance, ModelInstance);

            UnitTestUtility.AssertAreEqual(ViewModelInstance, ModelInstance);
        }

        private IPersonModelToViewModelAdapter m_AdapterInstance;
        public IPersonModelToViewModelAdapter AdapterInstance
        {
            get
            {
                if (m_AdapterInstance == null)
                {
                    m_AdapterInstance = new PersonModelToViewModelAdapter();
                }

                return m_AdapterInstance;
            }
        }

        private IPersonViewModel m_ViewModelInstance;
        public IPersonViewModel ViewModelInstance
        {
            get
            {
                if (m_ViewModelInstance == null)
                {
                    m_ViewModelInstance = new PersonViewModel();
                }

                return m_ViewModelInstance;
            }
        }

        private IPerson m_ModelInstance;
        public IPerson ModelInstance
        {
            get
            {
                if (m_ModelInstance == null)
                {
                    m_ModelInstance = new Person();
                }

                return m_ModelInstance;
            }
        }
    }
}