using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;
using Benday.MvvmTips.ViewModels;
using Microsoft.Silverlight.Testing;
using System.Threading;

namespace Benday.MvvmTips.UnitTests
{

    [TestClass]
    public class ProgressBarSampleViewModelFixture : SilverlightUnitTestBase
    {
        private bool m_Finished = false;
        private ProgressBarSampleViewModel m_Instance = new ProgressBarSampleViewModel();
        ProgressBarViewModelTester m_Tester;
            
        [TestMethod]
        [Asynchronous]
        [Tag("ProgressBar")]
        public void RunProgressBarShowsCorrectValues()
        {
            m_Instance.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(IsProgressBarVisibleChanged);

            m_Tester = new ProgressBarViewModelTester(m_Instance);

            m_Instance.RunProgressBar();

            EnqueueDelay(7000);
            EnqueueConditional(() => m_Finished);
            EnqueueCallback(() => AssertProgressBarValuesAndEndTest());                       
        }

        private void AssertProgressBarValuesAndEndTest()
        {
            m_Tester.AssertMessage("Starting to do stuff...");
            m_Tester.AssertMessage("Doing stuff...");
            m_Tester.AssertMessage("Watching TV...");
            m_Tester.AssertMessage("Getting some coffee...");
            m_Tester.AssertMessage("Finished.");

            m_Tester.AssertProgressBarWasVisibleAndEndedInvisible();

            EnqueueTestComplete();
        }
        private void IsProgressBarVisibleChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "IsProgressBarVisible")
            {
                if (m_Instance.IsProgressBarVisible == false)
                {
                    m_Finished = true;
                }
            }
        }
    }


}
