﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Threading;

namespace Benday.MvvmTips.Web
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class PersonService
    {
        [OperationContract]
        public PersonDto LoadById(int id)
        {
            var person = PretendToLoadPersonFromTheDatabase(id);
            return person;
        }

        [OperationContract]
        public PersonDto Save(PersonDto saveThis)
        {
            if (saveThis == null)
            {
                throw new ArgumentNullException("saveThis", "Argument cannot be null.");
            }

            PretendToSaveThisPersonToTheDatabase(saveThis);

            return saveThis;
        }

        private PersonDto PretendToLoadPersonFromTheDatabase(int id)
        {
            var person = new PersonDto();

            person.Id = id;
            person.FirstName = String.Format("FirstName_{0}", id);
            person.LastName = String.Format("LastName_{0}", id);
            person.EmailAddress = String.Format("{0}.{1}@someplace.org", person.FirstName, person.LastName);

            Thread.Sleep(1500);

            return person;
        }

        private void PretendToSaveThisPersonToTheDatabase(PersonDto saveThis)
        {
            if (saveThis.Id == 0)
            {
                saveThis.Id = new Random().Next(1, Int32.MaxValue);
            }

            Thread.Sleep(1500);
        }
    }
}
