using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Text;
using Benday.MvvmTips.Common;

namespace Benday.MvvmTips.Controls
{
    public class BendayBaseUserControl : UserControl
    {
        public BendayBaseUserControl()
        {

        }

        public void SetDataContext(IViewModelBase viewModel)
        {
            if (viewModel == null)
                throw new ArgumentNullException("viewModel", "viewModel is null.");

            DataContext = viewModel;

            viewModel.MessageBoxRequested += new MessageBoxEventHandler(viewModel_MessageBoxRequested);
        }

        void viewModel_MessageBoxRequested(object sender, MessageBoxEventArgs args)
        {
            if (args.IsUnexpectedException == true)
            {
                BendayMessageBox window = new BendayMessageBox();

                window.Initialize("Unexpected exception", args.Message, args.Exception.ToString());

                window.Show();
            }
            else if (args.Exception != null)
            {
                BendayMessageBox window = new BendayMessageBox();

                window.Initialize("Unhandled exception", args.Message, args.Exception.Message);

                window.Show();
            }
            else
            {
                BendayMessageBox window = new BendayMessageBox();

                window.Initialize("INFO", args.Message);

                window.Show();
            }
        }
    }
}
