﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Benday.MvvmTips.Controls
{
    public partial class ComboBoxField : UserControl
    {
        public ComboBoxField()
        {
            InitializeComponent();
        }

        private static void ShowDropDownValues(object sender)
        {
            FrameworkElement fe = sender as FrameworkElement;
            AutoCompleteBox acb = null;            

            while (fe != null && acb == null)
            {
                fe = VisualTreeHelper.GetParent(fe) as FrameworkElement;
                acb = fe as AutoCompleteBox;
            }

            ToggleDropDownList(acb);
        }

        private static void ToggleDropDownList(AutoCompleteBox acb)
        {
            if (acb != null)
            {
                if (string.IsNullOrEmpty(acb.SearchText))
                {
                    acb.Text = string.Empty;
                }
                acb.IsDropDownOpen = !acb.IsDropDownOpen;
            }
        }

        private void DropDownToggle_Click(object sender, RoutedEventArgs e)
        {
            //ShowDropDownValues(sender);
            ToggleDropDownList(m_autoCompleteBox);
        }

        public string LabelText
        {
            get
            {
                return (string)this.GetValue(LabelTextProperty);
            }
            set
            {
                if (value == null)
                {
                    this.SetValue(LabelTextProperty, String.Empty);                    
                }
                else
                {
                    string newValueToUpper = value.ToUpper();

                    this.SetValue(LabelTextProperty, newValueToUpper);
                    m_labelLeftRight.Text = newValueToUpper;
                }
            }
        }

        public static readonly DependencyProperty LabelTextProperty = DependencyProperty.Register(
          "LabelText", typeof(string), typeof(ComboBoxField), new PropertyMetadata(String.Empty));

        public GridLength LabelColumnWidth
        {
            get
            {
                return (GridLength)this.GetValue(LabelColumnWidthProperty);
            }
            set
            {
                this.SetValue(LabelColumnWidthProperty, value);
                m_columnForLabel.Width = value;                
            }
        }

        private static readonly GridLength DefaultLabelColumnWidthValue = new GridLength((double)200);
        public static readonly DependencyProperty LabelColumnWidthProperty = DependencyProperty.Register(
          "LabelColumnWidth", typeof(GridLength), typeof(ComboBoxField), new PropertyMetadata(DefaultLabelColumnWidthValue));

        private void UserControl_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            ToggleDropDownList(m_autoCompleteBox);
        }            
    }
}
