﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Benday.MvvmTips.Controls
{
    /// <summary>
    /// Interaction logic for ListboxField.xaml
    /// </summary>
    public partial class ListboxField : UserControl
    {
        public ListboxField()
        {
            InitializeComponent();
        }

        public static readonly DependencyProperty LabelTextProperty = DependencyProperty.Register(
          "LabelText", typeof(string), typeof(ListboxField), new PropertyMetadata(String.Empty));

        private static object OnCoerceLabelText(DependencyObject o, object value)
        {
            ListboxField ListboxField = o as ListboxField;
            if (ListboxField != null)
                return ListboxField.OnCoerceLabelText((string)value);
            else
                return value;
        }

        private static void OnLabelTextChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            ListboxField ListboxField = o as ListboxField;
            if (ListboxField != null)
                ListboxField.OnLabelTextChanged((string)e.OldValue, (string)e.NewValue);
        }

        protected virtual string OnCoerceLabelText(string value)
        {
            // TODO: Keep the proposed value within the desired range.
            return value;
        }

        private void SetLabelTextValue(string value)
        {
            if (value == null)
            {
                m_Label.Text = String.Empty;
            }
            else
            {
                m_Label.Text = value;
            }
        }

        protected virtual void OnLabelTextChanged(string oldValue, string newValue)
        {
            SetLabelTextValue(newValue);
        }

        public string LabelText
        {
            // IMPORTANT: To maintain parity between setting a property in XAML and procedural code, do not touch the getter and setter inside this dependency property!
            get
            {
                return (string)GetValue(LabelTextProperty);
            }
            set
            {
                SetValue(LabelTextProperty, value);
                SetLabelTextValue(value);
            }
        }
    }
}
