﻿using System;
using System.Windows.Data;

namespace Benday.MvvmTips.Controls
{
    public class StringOrInt32ValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null)
            {
                return String.Empty;
            }
            else
            {
                return value.ToString();
            }
        }

        private object ConvertBackForInt32(object value)
        {
            if (value == null)
            {
                return 0;
            }
            else
            {
                string valueAsString = value.ToString();

                if (String.IsNullOrEmpty(valueAsString) == true)
                {
                    return 0;
                }
                else
                {
                    int returnValue = 0;

                    if (Int32.TryParse(valueAsString, out returnValue) == true)
                    {
                        return returnValue;
                    }
                    else
                    {
                        return 0;
                    }
                }
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(Int32))
            {
                return ConvertBackForInt32(value);
            }
            else
            {
                return value;
            }
        }
    }
}
