using System;
using System.Windows.Data;
using System.Globalization;
using System.Windows;

namespace Benday.MvvmTips.Helpers
{
    public class NotVisibilityValueConverter : IValueConverter
    {
        public object Convert(
            object value,
            Type targetType,
            object parameter,
            CultureInfo culture)
        {
            bool valueAsBoolean = (bool)value;

            if (valueAsBoolean == false)
            {
                return Visibility.Visible;
            }
            else
            {
                return Visibility.Collapsed;
            }
        }

        public object ConvertBack(
            object value,
            Type targetType,
            object parameter,
            CultureInfo culture)
        {
            Visibility valueAsVisibility = (Visibility)value;

            if (valueAsVisibility == Visibility.Visible)
            {
                return false;
            }
            else
            {
                return true;
            }
        }
    }
}
