using System;
using Benday.MvvmTips.Models;

namespace Benday.MvvmTips.ViewModels
{
    public class PersonModelToViewModelAdapter : IPersonModelToViewModelAdapter
    {
        public PersonModelToViewModelAdapter()
        {

        }

        public void Adapt(IPerson fromValue, IPersonViewModel toValue)
        {
            if (fromValue == null)
                throw new ArgumentNullException("fromValue", "fromValue is null.");
            if (toValue == null)
                throw new ArgumentNullException("toValue", "toValue is null.");

            toValue.Id.Value = fromValue.Id;
            toValue.FirstName.Value = fromValue.FirstName;
            toValue.LastName.Value = fromValue.LastName;
            toValue.EmailAddress.Value = fromValue.EmailAddress;            
        }

        public void Adapt(IPersonViewModel fromValue, IPerson toValue)
        {
            if (toValue == null)
                throw new ArgumentNullException("fromValue", "fromValue is null.");
            if (fromValue == null)
                throw new ArgumentNullException("toValue", "toValue is null.");

            toValue.Id = fromValue.Id.Value;
            toValue.FirstName = fromValue.FirstName.Value;
            toValue.LastName = fromValue.LastName.Value;
            toValue.EmailAddress = fromValue.EmailAddress.Value;
        }
    }
}
