using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Benday.MvvmTips.Common;
using Benday.MvvmTips.Models;
using Benday.MvvmTips.PersonService;

namespace Benday.MvvmTips.WcfDataAccess
{
    public class PersonModelToServiceDtoAdapter
    {
        public void Adapt(PersonService.PersonDto fromValue, IPerson toValue)
        {
            if (fromValue == null)
                throw new ArgumentNullException(
                    "fromValue", "fromValue is null.");
            if (toValue == null)
                throw new ArgumentNullException(
                    "toValue", "toValue is null.");

            toValue.Id = fromValue.Id;
            toValue.FirstName = fromValue.FirstName;
            toValue.LastName = fromValue.LastName;
            toValue.EmailAddress = fromValue.EmailAddress;
        }

        public void Adapt(IPerson fromValue, PersonService.PersonDto toValue)
        {
            if (fromValue == null)
                throw new ArgumentNullException(
                    "fromValue", "fromValue is null.");
            if (toValue == null)
                throw new ArgumentNullException(
                    "toValue", "toValue is null.");

            toValue.Id = fromValue.Id;
            toValue.FirstName = fromValue.FirstName;
            toValue.LastName = fromValue.LastName;
            toValue.EmailAddress = fromValue.EmailAddress;
        }
    }
}
